/* Qaquarelle
 * Copyright (C) 2009 Vasiliy Makarov <drmoriarty.0@gmail.com>
 *
 * This is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this software; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef NEWPAINTING_H
#define NEWPAINTING_H

#include <QtGui>
#include "ui_newpainting.h"


enum eNewPainting_technique {
    NEWPAINTING_WATERCOLORS = 0,
    NEWPAINTING_OILS        = 1,
    NEWPAINTING_SKETCH      = 2
};

typedef struct _PaintingSettings {
    long width;
    long height;
    int sizeType;
    int dpi;
    int technique;
    QString tmplt_name;

    _PaintingSettings(): width(0), height(0), sizeType(0), dpi(100), tmplt_name("") {}
    _PaintingSettings(long w, long h, int dpi, int type, QString name) {
        width      = w;
        height     = h;
        dpi        = dpi;
        sizeType   = type;
        tmplt_name = name;
    }
} PaintingSettings;


class NewPainting : public QDialog
{
	Q_OBJECT
 public:
	NewPainting(PaintingSettings *set, QWidget *parent = 0);
 public slots:
	void setTemplate(int);
 private:
	Ui::NewPainting ui;
	PaintingSettings *settings;
 private slots:
	void storeSettings();
};

#endif // NEWPAINTING_H
