/***************************************************************************
 *  Copyright (C) 2009 by Anton R. <commanderkyle@gmail.com>
 *
 *  This file is a part of QAquarelle project.
 *
 *  QAquarelle is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  QAquarelle is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with QAquarelle.  If not, see <http://www.gnu.org/licenses/>.
 */
#include "arraygrid_patch.h"
#include <xmmintrin.h>


void Patch::checkStatus (void) {
    if ((m_Status == PATCHSTAT_UNKNOWN ||
        (m_Status & PATCHSTAT_WET)) &&
         m_Data) {
        // Rescan the patch to check whether
        // it is still active.
        const BYTE * line = (const BYTE *) m_Data->lock_pointer_const ();
        if (line) {
            const long pitch = m_Data->element_size () * m_Data->width ();

            BYTE ma[16] __attribute__((aligned(16))) = {
                0, 0, 0, 0, 0, 0, 0, 0,
                0, 0, 0, 0, 0, 0, 0, 0
            };

            // FIXME Optimization needed.
            for (int y = m_Data->height () / 2; y; y--, line += pitch) {
                const BYTE * p = line;
                for (int x = m_Data->width () / 2 / 4; x; x--, p += 4 * 4) {
                    for (int i = 0; i < 16; i++) {
                        ma[i] = MAX (ma[i], p[i]);
                    }
                }
            }

            ma[0] = MAX (ma[0], ma[4]);
            ma[1] = MAX (ma[1], ma[5]);
            ma[2] = MAX (ma[2], ma[6]);
            ma[3] = MAX (ma[3], ma[7]);
            ma[0] = MAX (ma[0], ma[8]);
            ma[1] = MAX (ma[1], ma[9]);
            ma[2] = MAX (ma[2], ma[10]);
            ma[3] = MAX (ma[3], ma[11]);
            ma[0] = MAX (ma[0], ma[12]);
            ma[1] = MAX (ma[1], ma[13]);
            ma[2] = MAX (ma[2], ma[14]);
            ma[3] = MAX (ma[3], ma[15]);

            m_Data->unlock ();

            // Update the status.
            m_Status = PATCHSTAT_NONE;
            if (ma[3] > 4) m_Status |= PATCHSTAT_WET;
            if (ma[0] > 4 ||
                ma[1] > 4 ||
                ma[2] > 4) m_Status |= PATCHSTAT_FILLED;
        }
    }
}

