/***
 *  Copyright (C) 2009 Anton R. <commanderkyle@gmail.com>
 *
 *  This file is a part of QAquarelle project.
 *
 *  QAquarelle is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  QAquarelle is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with QAquarelle.  If not, see <http://www.gnu.org/licenses/>.
 */
#include "basicdynamics.h"
#include "pipeline_stage0.h"


BasicDynamics::BasicDynamics (void) {
    m_Id = ISpawnedObject::allocateId ();

    // Not registering static objects?
    //ISpawnedObject::_register (this);
    m_Logger = NULL;
}

BasicDynamics::~BasicDynamics (void) {
    //ISpawnedObject::_unregister (this);
    SAFE_RELEASE (m_Logger);
}

IPipeline * BasicDynamics::create (int index, IOpenGLHelper * helper) {
    switch (index) {
        case 0:
            return new Pipeline_stage0 (helper);
            break;
    }

    return NULL;
}

Q_EXPORT_PLUGIN2 (basicdynamics, BasicDynamics);
